/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  input.plx

\***************************************************************************/

#if !defined(INPUT_PLX)
#define INPUT_PLX
#define ll3input_name   "INPUT"
/* Argument definitions for C-callable functions */
#define LPI_PRM_CONSTRUCT_ARGS          (lptr(CONTEXT)         LpiContext,\
                                         lptr(LpiPromptType)   promptMptr,\
                                         lmhdl(lmbcs)          promptstr)
#define LPI_PRM_SET_TITLE_ARGS          (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lmhdl(lmbcs)          promptstr)
#define LPI_PRM_GET_TITLE_ARGS          (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lptr(lmhdl(lmbcs))    promptstr)
#define LPI_PRM_GET_KEY_ARGS            (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lptr(lushort)         term_key)
#define LPI_PRM_SET_LENGTH_ARGS         (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lslong                theLength)
#define LPI_PRM_GET_LENGTH_ARGS         (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lptr(lslong)          theLength)
#define LPI_PRM_SET_END_COLUMN_ARGS     (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lslong                theColumn)
#define LPI_PRM_GET_END_COLUMN_ARGS     (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lptr(lslong)          theColumn)
#define LPI_PRM_SET_DEFAULT_STRING_ARGS (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lmhdl(lmbcs)          defaultMptr)
#define LPI_PRM_SET_DEFAULT_INT_ARGS    (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lslong                defaultInteger)
#define LPI_PRM_SET_DEFAULT_FLOAT_ARGS  (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lfloat10              defaultFloat)
#define LPI_PRM_GET_DEFAULT_STRING_ARGS (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lptr(lmhdl(lmbcs))    promptStr)
#define LPI_PRM_GET_DEFAULT_INT_ARGS    (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lptr(lslong)          theInteger)
#define LPI_PRM_GET_DEFAULT_FLOAT_ARGS  (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lptr(lfloat10)        theFloat)
#define LPI_PRM_SET_MIN_ARGS            (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lslong                minIntValue)
#define LPI_PRM_GET_MIN_ARGS            (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lptr(lslong)          minIntValue)
#define LPI_PRM_SET_MAX_ARGS            (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lslong                maxIntValue)
#define LPI_PRM_GET_MAX_ARGS            (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lptr(lslong)          maxIntValue)
#define LPI_PRM_SET_ROW_ARGS            (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lslong                rowValue)
#define LPI_PRM_GET_ROW_ARGS            (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lptr(lslong)          rowValue)
#define LPI_PRM_SET_COLUMN_ARGS         (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lslong                columnValue)
#define LPI_PRM_GET_COLUMN_ARGS         (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lptr(lslong)          columnValue)
#define LPI_PRM_SET_RESPONSE_MODE_ARGS  (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lushort               rmode)
#define LPI_PRM_GET_RESPONSE_MODE_ARGS  (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lptr(lushort)         rmode)
#define LPI_PRM_SET_HELP_ARGS           (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lslong                mptrCnt,\
                                         lmhdl(lmhdl(lmbcs))   helpArray)
#define LPI_PRM_INPUT_STRING_ARGS       (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lmhdl(lmbcs)          theString,\
                                         lptr(lmhdl(lmbcs))    outputStr)
#define LPI_PRM_INPUT_INTEGER_ARGS      (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lslong                inInt,\
                                         lptr(lslong)          outInt)
#define LPI_PRM_INPUT_FLOAT_ARGS        (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lfloat10              inFloat,\
                                         lbool                 inputValid,\
                                         lptr(lfloat10)        outFloat)
#define LPI_PRM_GET_PROMPT_STRING_ARGS  (lptr(CONTEXT)         LpiContext,\
                                         LpiPromptType         promptMptr,\
                                         lptr(lmhdl(lmbcs))    theString)
#define LPI_MNU_CONSTRUCT_ARGS          (lptr(CONTEXT)         LpiContext,\
                                         lptr(LpiMenuType)     menuMptr,\
                                         lmhdl(lmhdl(lmbcs))   promptArray,\
                                         lushort               promptCount)
#define LPI_MNU_SET_HELP_ARGS           (lptr(CONTEXT)         LpiContext,\
                                         LpiMenuType           menuMptr,\
                                         lslong                mptrCnt,\
                                         lmhdl(lmhdl(lmbcs))   helpArray)
#define LPI_MNU_INPUT_ARGS              (lptr(CONTEXT)         LpiContext,\
                                         LpiMenuType           menuMptr,\
                                         lptr(lsshort)         menuChoice)
#define LPI_MNU_STRING_ARGS             (lptr(CONTEXT)         LpiContext,\
                                         LpiMenuType           menuMptr,\
                                         lptr(lmhdl(lmbcs))    theString)
#define LPI_KBD_CONSTRUCT_ARGS          (lptr(CONTEXT)         LpiContext,\
                                         lptr(LpiKeyboardType) keyMptr)
#define LPI_KBD_DESTROY_ARGS            (lptr(CONTEXT)         LpiContext,\
                                         lptr(LpiKeyboardType) keyMptr)
#define LPI_KBD_INPUT_ARGS              (lptr(CONTEXT)         LpiContext,\
                                         LpiKeyboardType       keyMptr,\
                                         lslong                timeout,\
                                         lptr(lmbcs)           outs)
#define LPI_KBD_STRING_ARGS             (lptr(CONTEXT)         LpiContext,\
                                         LpiKeyboardType       keyMptr,\
                                         lptr(lmhdl(lmbcs))    theString)
#define LPI_PRM_DESTROY_ARGS            (lptr(CONTEXT)         LpiContext,\
                                         lptr(LpiPromptType)   promptMptr)
#define LPI_MNU_DESTROY_ARGS            (lptr(CONTEXT)         LpiContext,\
                                         lptr(LpiMenuType)     menuMptr)
/* typedefs for C callable functions */
lexppro (lsshort, lpi_prm_set_title, LPI_PRM_SET_TITLE_ARGS);
lexppro (lsshort, lpi_prm_construct, LPI_PRM_CONSTRUCT_ARGS);
lexppro (lsshort, lpi_prm_get_key, LPI_PRM_GET_KEY_ARGS);
lexppro (lsshort, lpi_prm_get_title, LPI_PRM_GET_TITLE_ARGS);
lexppro (lsshort, lpi_prm_set_length, LPI_PRM_SET_LENGTH_ARGS);
lexppro (lsshort, lpi_prm_get_length, LPI_PRM_GET_LENGTH_ARGS);
lexppro (lsshort, lpi_prm_set_end_column, LPI_PRM_SET_END_COLUMN_ARGS);
lexppro (lsshort, lpi_prm_get_end_column, LPI_PRM_GET_END_COLUMN_ARGS);
lexppro (lsshort, lpi_prm_set_default_string, LPI_PRM_SET_DEFAULT_STRING_ARGS);
lexppro (lsshort, lpi_prm_set_default_int, LPI_PRM_SET_DEFAULT_INT_ARGS);
lexppro (lsshort, lpi_prm_set_default_float, LPI_PRM_SET_DEFAULT_FLOAT_ARGS);
lexppro (lsshort, lpi_prm_get_default_string, LPI_PRM_GET_DEFAULT_STRING_ARGS);
lexppro (lsshort, lpi_prm_get_default_int, LPI_PRM_GET_DEFAULT_INT_ARGS);
lexppro (lsshort, lpi_prm_get_default_float, LPI_PRM_GET_DEFAULT_FLOAT_ARGS);
lexppro (lsshort, lpi_prm_set_min, LPI_PRM_SET_MIN_ARGS);
lexppro (lsshort, lpi_prm_get_min, LPI_PRM_GET_MIN_ARGS);
lexppro (lsshort, lpi_prm_set_max, LPI_PRM_SET_MAX_ARGS);
lexppro (lsshort, lpi_prm_get_max, LPI_PRM_GET_MAX_ARGS);
lexppro (lsshort, lpi_prm_set_row, LPI_PRM_SET_ROW_ARGS);
lexppro (lsshort, lpi_prm_get_row, LPI_PRM_GET_ROW_ARGS);
lexppro (lsshort, lpi_prm_set_column, LPI_PRM_SET_COLUMN_ARGS);
lexppro (lsshort, lpi_prm_get_column, LPI_PRM_GET_COLUMN_ARGS);
lexppro (lsshort, lpi_prm_set_response_mode, LPI_PRM_SET_RESPONSE_MODE_ARGS);
lexppro (lsshort, lpi_prm_get_response_mode, LPI_PRM_GET_RESPONSE_MODE_ARGS);
lexppro (lsshort, lpi_prm_set_help, LPI_PRM_SET_HELP_ARGS);
lexppro (lsshort, lpi_prm_input_string, LPI_PRM_INPUT_STRING_ARGS);
lexppro (lsshort, lpi_prm_input_integer, LPI_PRM_INPUT_INTEGER_ARGS);
lexppro (lsshort, lpi_prm_input_float, LPI_PRM_INPUT_FLOAT_ARGS);
lexppro (lsshort, lpi_prm_get_prompt_string, LPI_PRM_GET_PROMPT_STRING_ARGS);
lexppro (lsshort, lpi_mnu_construct, LPI_MNU_CONSTRUCT_ARGS);
lexppro (lsshort, lpi_mnu_set_help, LPI_MNU_SET_HELP_ARGS);
lexppro (lsshort, lpi_mnu_input, LPI_MNU_INPUT_ARGS);
lexppro (lsshort, lpi_mnu_string, LPI_MNU_STRING_ARGS);
lexppro (lsshort, lpi_kbd_construct, LPI_KBD_CONSTRUCT_ARGS);
lexppro (lsshort, lpi_kbd_destroy, LPI_KBD_DESTROY_ARGS);
lexppro (lsshort, lpi_kbd_input, LPI_KBD_INPUT_ARGS);
lexppro (lsshort, lpi_kbd_string, LPI_KBD_STRING_ARGS);
lexppro (lsshort, lpi_prm_destroy, LPI_PRM_DESTROY_ARGS);
lexppro (lsshort, lpi_mnu_destroy, LPI_MNU_DESTROY_ARGS);
/* Pointers to C callable functions */
typedef struct {
    lexpptr (lsshort, lpi_prm_set_title, LPI_PRM_SET_TITLE_ARGS);
    lexpptr (lsshort, lpi_prm_construct, LPI_PRM_CONSTRUCT_ARGS);
    lexpptr (lsshort, lpi_prm_get_key, LPI_PRM_GET_KEY_ARGS);
    lexpptr (lsshort, lpi_prm_get_title, LPI_PRM_GET_TITLE_ARGS);
    lexpptr (lsshort, lpi_prm_set_length, LPI_PRM_SET_LENGTH_ARGS);
    lexpptr (lsshort, lpi_prm_get_length, LPI_PRM_GET_LENGTH_ARGS);
    lexpptr (lsshort, lpi_prm_set_end_column, LPI_PRM_SET_END_COLUMN_ARGS);
    lexpptr (lsshort, lpi_prm_get_end_column, LPI_PRM_GET_END_COLUMN_ARGS);
    lexpptr (lsshort, lpi_prm_set_default_string, LPI_PRM_SET_DEFAULT_STRING_ARGS);
    lexpptr (lsshort, lpi_prm_set_default_int, LPI_PRM_SET_DEFAULT_INT_ARGS);
    lexpptr (lsshort, lpi_prm_set_default_float, LPI_PRM_SET_DEFAULT_FLOAT_ARGS);
    lexpptr (lsshort, lpi_prm_get_default_string, LPI_PRM_GET_DEFAULT_STRING_ARGS);
    lexpptr (lsshort, lpi_prm_get_default_int, LPI_PRM_GET_DEFAULT_INT_ARGS);
    lexpptr (lsshort, lpi_prm_get_default_float, LPI_PRM_GET_DEFAULT_FLOAT_ARGS);
    lexpptr (lsshort, lpi_prm_set_min, LPI_PRM_SET_MIN_ARGS);
    lexpptr (lsshort, lpi_prm_get_min, LPI_PRM_GET_MIN_ARGS);
    lexpptr (lsshort, lpi_prm_set_max, LPI_PRM_SET_MAX_ARGS);
    lexpptr (lsshort, lpi_prm_get_max, LPI_PRM_GET_MAX_ARGS);
    lexpptr (lsshort, lpi_prm_set_row, LPI_PRM_SET_ROW_ARGS);
    lexpptr (lsshort, lpi_prm_get_row, LPI_PRM_GET_ROW_ARGS);
    lexpptr (lsshort, lpi_prm_set_column, LPI_PRM_SET_COLUMN_ARGS);
    lexpptr (lsshort, lpi_prm_get_column, LPI_PRM_GET_COLUMN_ARGS);
    lexpptr (lsshort, lpi_prm_set_response_mode, LPI_PRM_SET_RESPONSE_MODE_ARGS);
    lexpptr (lsshort, lpi_prm_get_response_mode, LPI_PRM_GET_RESPONSE_MODE_ARGS);
    lexpptr (lsshort, lpi_prm_set_help, LPI_PRM_SET_HELP_ARGS);
    lexpptr (lsshort, lpi_prm_input_string, LPI_PRM_INPUT_STRING_ARGS);
    lexpptr (lsshort, lpi_prm_input_integer, LPI_PRM_INPUT_INTEGER_ARGS);
    lexpptr (lsshort, lpi_prm_input_float, LPI_PRM_INPUT_FLOAT_ARGS);
    lexpptr (lsshort, lpi_prm_get_prompt_string, LPI_PRM_GET_PROMPT_STRING_ARGS);
    lexpptr (lsshort, lpi_mnu_construct, LPI_MNU_CONSTRUCT_ARGS);
    lexpptr (lsshort, lpi_mnu_set_help, LPI_MNU_SET_HELP_ARGS);
    lexpptr (lsshort, lpi_mnu_input, LPI_MNU_INPUT_ARGS);
    lexpptr (lsshort, lpi_mnu_string, LPI_MNU_STRING_ARGS);
    lexpptr (lsshort, lpi_kbd_construct, LPI_KBD_CONSTRUCT_ARGS);
    lexpptr (lsshort, lpi_kbd_destroy, LPI_KBD_DESTROY_ARGS);
    lexpptr (lsshort, lpi_kbd_input, LPI_KBD_INPUT_ARGS);
    lexpptr (lsshort, lpi_kbd_string, LPI_KBD_STRING_ARGS);
    lexpptr (lsshort, lpi_prm_destroy, LPI_PRM_DESTROY_ARGS);
    lexpptr (lsshort, lpi_mnu_destroy, LPI_MNU_DESTROY_ARGS);
} in_exports;
/* SPR #121397 */
#define LPI_KBD_INPUT_BUFLEN    4       /* For use with Input(Keyboard) */
#if !defined(LPI_MIN_LSSHORT)
#define LPI_MIN_LSSHORT 0x10000000
#endif
#if defined(LPIXPORT_H) /* macros to call the structure stuff */
#if !defined(LPI_KBD_NO_TIMEOUT)
#if !defined(LPI_MIN_LSLONG)
#define LPI_MIN_LSLONG -2147483647
#endif
#define LPI_KBD_NO_TIMEOUT  LPI_MIN_LSLONG
#endif
#if defined(NOGLOBALDATA)
#define LPI_IN_GLOBAL_REF  LPI_CALL_DATA->in_global
#define LPI_IN_TABLE_REF   LPI_CALL_DATA->in_table
#else
#define LPI_IN_GLOBAL_REF  lts_in_global
#define LPI_IN_TABLE_REF   lts_in_table
#endif
/* prompt ADT procedures */
#define LpiPrmConstruct(xADTdata)                           \
        (*LPI_IN_TABLE_REF->lpi_prm_construct)              \
        (LPI_IN_GLOBAL_REF, xADTdata, (lslong)LNULL )
#define LpiPrmConstructTitle(xADTdata, arg1 )               \
        (*LPI_IN_TABLE_REF->lpi_prm_construct)              \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1 )
#define LpiPrmDestroy(xADTdata)                             \
        (*LPI_IN_TABLE_REF->lpi_prm_destroy)             \
        (LPI_IN_GLOBAL_REF, xADTdata)
#define LpiPrmSetTitle(xADTdata, arg1)                      \
        (*LPI_IN_TABLE_REF->lpi_prm_set_title)               \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#define LpiPrmGetKey(xADTdata, arg1)                        \
        (*LPI_IN_TABLE_REF->lpi_prm_get_key)                 \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#define LpiPrmGetTitle(xADTdata, arg1)                      \
        (*LPI_IN_TABLE_REF->lpi_prm_get_title)               \
        (LPI_IN_GLOBAL_REF,xADTdata, arg1)
#define LpiPrmSetLength(xADTdata, arg1)                     \
        (*LPI_IN_TABLE_REF->lpi_prm_set_length)              \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#define LpiPrmGetLength(xADTdata, arg1)                     \
        (*LPI_IN_TABLE_REF->lpi_prm_get_length)              \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#define LpiPrmSetEndColumn(xADTdata, arg1)                  \
        (*LPI_IN_TABLE_REF->lpi_prm_set_end_column)          \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#define LpiPrmGetEndColumn(xADTdata, arg1)                  \
        (*LPI_IN_TABLE_REF->lpi_prm_get_end_column)          \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#define LpiPrmSetDefaultString(xADTdata, arg1)              \
        (*LPI_IN_TABLE_REF->lpi_prm_set_default_string)         \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#define LpiPrmSetDefaultInt(xADTdata, arg1)                 \
        (*LPI_IN_TABLE_REF->lpi_prm_set_default_int)         \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#define LpiPrmSetDefaultFloat(xADTdata, arg1)               \
        (*LPI_IN_TABLE_REF->lpi_prm_set_default_float)       \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#define LpiPrmGetDefaultString(xADTdata, arg1)              \
        (*LPI_IN_TABLE_REF->lpi_prm_get_default_string)         \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#define LpiPrmGetDefaultInt(xADTdata, arg1)                 \
        (*LPI_IN_TABLE_REF->lpi_prm_get_default_int)         \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#define LpiPrmGetDefaultFloat(xADTdata, arg1)               \
        (*LPI_IN_TABLE_REF->lpi_prm_get_default_float)       \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#define LpiPrmSetMin(xADTdata, arg1)                        \
        (*LPI_IN_TABLE_REF->lpi_prm_set_min)                 \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#define LpiPrmGetMin(xADTdata, arg1)                        \
        (*LPI_IN_TABLE_REF->lpi_prm_get_min)                 \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#define LpiPrmSetMax(xADTdata, arg1)                        \
        (*LPI_IN_TABLE_REF->lpi_prm_set_max)                 \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#define LpiPrmGetMax(xADTdata, arg1)                        \
        (*LPI_IN_TABLE_REF->lpi_prm_get_max)                 \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#define LpiPrmSetRow(xADTdata, arg1)                        \
        (*LPI_IN_TABLE_REF->lpi_prm_set_row)                 \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#define LpiPrmGetRow(xADTdata, arg1)                        \
        (*LPI_IN_TABLE_REF->lpi_prm_get_row)                 \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#define LpiPrmSetColumn(xADTdata, arg1)                     \
        (*LPI_IN_TABLE_REF->lpi_prm_set_column)              \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#define LpiPrmGetColumn(xADTdata, arg1)                     \
        (*LPI_IN_TABLE_REF->lpi_prm_get_column)              \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#define LpiPrmSetResponseMode(xADTdata, arg1)               \
        (*LPI_IN_TABLE_REF->lpi_prm_set_response_mode)       \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#define LpiPrmGetResponseMode(xADTdata, arg1)               \
        (*LPI_IN_TABLE_REF->lpi_prm_get_response_mode)       \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#define LpiPrmSetHelp(xADTdata, arg1, arg2)                 \
        (*LPI_IN_TABLE_REF->lpi_prm_set_help)                \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiPrmInputString(xADTdata, arg1)                   \
        (*LPI_IN_TABLE_REF->lpi_prm_input_string)               \
        (LPI_IN_GLOBAL_REF, xADTdata, LNULL, arg1)
#define LpiPrmInputStringDefault(xADTdata, arg1, arg2)      \
        (*LPI_IN_TABLE_REF->lpi_prm_input_string)               \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiPrmInputInt(xADTdata, arg1)                      \
        (*LPI_IN_TABLE_REF->lpi_prm_input_integer)           \
        (LPI_IN_GLOBAL_REF, xADTdata, (lulong)LPI_MIN_LSSHORT, arg1)
#define LpiPrmInputIntDefault(xADTdata, arg1, arg2)         \
        (*LPI_IN_TABLE_REF->lpi_prm_input_integer)           \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiPrmInputFloat(xADTdata, arg1)                    \
        (*LPI_IN_TABLE_REF->lpi_prm_input_float)             \
        (LPI_IN_GLOBAL_REF, xADTdata, *arg1, LFALSE, arg1)
#define LpiPrmInputFloatDefault(xADTdata, arg1, arg2)       \
        (*LPI_IN_TABLE_REF->lpi_prm_input_float)             \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1, LTRUE, arg2)
#define LpiPrmString(xADTdata, arg1)                        \
        (*LPI_IN_TABLE_REF->lpi_prm_get_prompt_string)          \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
/* menu ADT procedures */
#define LpiMnuConstruct(xADTdata, arg1, arg2)               \
        (*LPI_IN_TABLE_REF->lpi_mnu_construct)              \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiMnuDestroy(xADTdata)                             \
        (*LPI_IN_TABLE_REF->lpi_mnu_destroy)               \
        (LPI_IN_GLOBAL_REF, xADTdata)
#define LpiMnuSetHelp(xADTdata, arg1, arg2)                 \
        (*LPI_IN_TABLE_REF->lpi_mnu_set_help)            \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiMnuInput(xADTdata, arg1 )                        \
        (*LPI_IN_TABLE_REF->lpi_mnu_input)              \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1 )
#define LpiMnuString(xADTdata, arg1)                        \
        (*LPI_IN_TABLE_REF->lpi_mnu_string)            \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
/* keyboard ADT procedures */
#define LpiKbdConstruct(xADTdata)                           \
        (*LPI_IN_TABLE_REF->lpi_kbd_construct)              \
        (LPI_IN_GLOBAL_REF, xADTdata)
#define LpiKbdDestroy(xADTdata)                             \
        (*LPI_IN_TABLE_REF->lpi_kbd_destroy)           \
        (LPI_IN_GLOBAL_REF, xADTdata)
#define LpiKbdInput(xADTdata, arg1)                         \
        (*LPI_IN_TABLE_REF->lpi_kbd_input)          \
        (LPI_IN_GLOBAL_REF, xADTdata, LPI_KBD_NO_TIMEOUT, arg1 )
#define LpiKbdInputTimeout(xADTdata, arg1, arg2 )           \
        (*LPI_IN_TABLE_REF->lpi_kbd_input)          \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1, arg2 )
#define LpiKbdString(xADTdata, arg1)                        \
        (*LPI_IN_TABLE_REF->lpi_kbd_string)        \
        (LPI_IN_GLOBAL_REF, xADTdata, arg1)
#endif
#endif
