;***************************************************************************
; This .ASM file is a template for the one that you will need to create
; in order to have 1-2-3 locate your Bind and Unbind routine in DOS.
; Use the directions in the comments below to change it to work with your
; add-in.
;
; Remember:  Order is important, the bind routine always comes before the
;               unbind routine.
;***************************************************************************


   DOSSEG

addn_text segment byte public 'CODE'
        assume cs:addn_text

;************************************************************************
; Change the next 2 lines to include the name of your bind and unbind
; routine. For example:
;
; extrn <bind routine name>:far
; extrn <unbind routine name>:far
;************************************************************************
        extrn template_b:far
        extrn template_u:far


linkbase:
addn_text ends

NULL_DATA segment para public 'FAR_BSS'
NULL_DATA ends

DGROUP group  _DATA
_DATA  segment  word public 'DATA'
_DATA  ends

addn_text segment

;************************************************************************
; Change the next 2 lines to include the name of your bind and unbind
; routine. For example:
;
; dd <bind routine name>
; dd <unbind routine name>
;************************************************************************
        dd template_b
        dd template_u
        dw seg NULL_DATA        ; reference for DOS/16M.

addn_text ends

;************************************************************************
;dummy stack to prevent linker warning
;************************************************************************

stack           segment stack
stack           ends

      end linkbase




