/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  atspcl.plx

\***************************************************************************/

#if !defined(ATSPCL_PLX)
#define ATSPCL_PLX
#define ll3atspcl_name     "ATSPCL"
/* input arg = float, bit 0 =0, output arg = float, bit 1 = 0 */
/* input arg = string, bit 0 =1, output arg = string, bit 1 = 1 */
#define LPI_FLOAT_IN    0X00
#define LPI_FLOAT_OUT   0X00
#define LPI_STR_IN      0X01
#define LPI_STR_OUT     0X10
#define LPI_FTOF        LPI_FLOAT_IN | LPI_FLOAT_OUT
#define LPI_FTOS        LPI_FLOAT_IN | LPI_STR_OUT
#define LPI_STOF        LPI_STR_IN | LPI_FLOAT_OUT
#define LPI_STOS        LPI_STR_IN | LPI_STR_OUT
typedef union {
   lfloat10       flt;
   lmhdl(lmbcs)  str;
} lpi_arg_type;
/* Argument definitions for C-callable functions */
#define LPI_ATSPC_HLOOKUP_FTOF_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 lookuparg,\
 LpiRangeType theRange,\
 lslong row,\
 lptr(lfloat10) outarg)
#define LPI_ATSPC_HLOOKUP_FTOS_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 lookuparg,\
 LpiRangeType theRange,\
 lslong row,\
 lptr(lmhdl(lmbcs)) outarg)
#define LPI_ATSPC_HLOOKUP_STOF_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmbcs) lookuparg,\
 LpiRangeType theRange,\
 lslong row,\
 lptr(lfloat10) outarg)
#define LPI_ATSPC_HLOOKUP_STOS_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmbcs) lookuparg,\
 LpiRangeType theRange,\
 lslong row,\
 lptr(lmhdl(lmbcs)) outarg)
#define LPI_ATSPC_INFO_FLOAT_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lushort infotype,\
 lptr(lfloat10) outarg)
#define LPI_ATSPC_INFO_STR_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lushort infotype,\
 lptr(lmhdl(lmbcs)) outarg)
#define LPI_ATSPC_VLOOKUP_FTOF_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 lookuparg,\
 LpiRangeType theRange,\
 lslong col,\
 lptr(lfloat10) outarg)
#define LPI_ATSPC_VLOOKUP_FTOS_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 lookuparg,\
 LpiRangeType theRange,\
 lslong col,\
 lptr(lmhdl(lmbcs)) outarg)
#define LPI_ATSPC_VLOOKUP_STOF_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmbcs) lookuparg,\
 LpiRangeType theRange,\
 lslong col,\
 lptr(lfloat10) outarg)
#define LPI_ATSPC_VLOOKUP_STOS_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmbcs) lookuparg,\
 LpiRangeType theRange,\
 lslong col,\
 lptr(lmhdl(lmbcs)) outarg)
#define LPI_ATSPC_ROUND_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 thenum,\
 lslong places,\
 lptr(lfloat10) outarg)
/* Function prototypes for C-callable functions */
lexppro (lsshort, lpi_atspc_hlookup_ftof, LPI_ATSPC_HLOOKUP_FTOF_ARGS);
lexppro (lsshort, lpi_atspc_hlookup_ftos, LPI_ATSPC_HLOOKUP_FTOS_ARGS);
lexppro (lsshort, lpi_atspc_hlookup_stof, LPI_ATSPC_HLOOKUP_STOF_ARGS);
lexppro (lsshort, lpi_atspc_hlookup_stos, LPI_ATSPC_HLOOKUP_STOS_ARGS);
lexppro (lsshort, lpi_atspc_info_float, LPI_ATSPC_INFO_FLOAT_ARGS);
lexppro (lsshort, lpi_atspc_info_str, LPI_ATSPC_INFO_STR_ARGS);
lexppro (lsshort, lpi_atspc_round, LPI_ATSPC_ROUND_ARGS);
lexppro (lsshort, lpi_atspc_vlookup_ftof, LPI_ATSPC_VLOOKUP_FTOF_ARGS);
lexppro (lsshort, lpi_atspc_vlookup_ftos, LPI_ATSPC_VLOOKUP_FTOS_ARGS);
lexppro (lsshort, lpi_atspc_vlookup_stof, LPI_ATSPC_VLOOKUP_STOF_ARGS);
lexppro (lsshort, lpi_atspc_vlookup_stos, LPI_ATSPC_VLOOKUP_STOS_ARGS);
typedef struct {
    lexpptr (lsshort, lpi_atspc_hlookup_ftof, LPI_ATSPC_HLOOKUP_FTOF_ARGS);
    lexpptr (lsshort, lpi_atspc_hlookup_ftos, LPI_ATSPC_HLOOKUP_FTOS_ARGS);
    lexpptr (lsshort, lpi_atspc_hlookup_stof, LPI_ATSPC_HLOOKUP_STOF_ARGS);
    lexpptr (lsshort, lpi_atspc_hlookup_stos, LPI_ATSPC_HLOOKUP_STOS_ARGS);
    lexpptr (lsshort, lpi_atspc_info_float, LPI_ATSPC_INFO_FLOAT_ARGS);
    lexpptr (lsshort, lpi_atspc_info_str, LPI_ATSPC_INFO_STR_ARGS);
    lexpptr (lsshort, lpi_atspc_round, LPI_ATSPC_ROUND_ARGS);
    lexpptr (lsshort, lpi_atspc_vlookup_ftof, LPI_ATSPC_VLOOKUP_FTOF_ARGS);
    lexpptr (lsshort, lpi_atspc_vlookup_ftos, LPI_ATSPC_VLOOKUP_FTOS_ARGS);
    lexpptr (lsshort, lpi_atspc_vlookup_stof, LPI_ATSPC_VLOOKUP_STOF_ARGS);
    lexpptr (lsshort, lpi_atspc_vlookup_stos, LPI_ATSPC_VLOOKUP_STOS_ARGS);
} atspcl_exports;
#if defined(LPIXPORT_H) /* macros to call the structure stuff */
#if defined(NOGLOBALDATA)
#define LPI_ATSPC_GLOBAL_REF  LPI_CALL_DATA->atspc_global
#define LPI_ATSPC_TABLE_REF   LPI_CALL_DATA->atspc_table
#else
#define LPI_ATSPC_GLOBAL_REF  lts_atspc_global
#define LPI_ATSPC_TABLE_REF   lts_atspc_table
#endif
#define LpiAtspcHlookupFtoF(arg1, arg2, arg3, arg4)             \
            (*LPI_ATSPC_TABLE_REF->lpi_atspc_hlookup_ftof)      \
            (LPI_ATSPC_GLOBAL_REF, arg1, arg2, arg3, arg4)
#define LpiAtspcHlookupFtoS(arg1, arg2, arg3, arg4)             \
            (*LPI_ATSPC_TABLE_REF->lpi_atspc_hlookup_ftos)      \
            (LPI_ATSPC_GLOBAL_REF, arg1, arg2, arg3, arg4)
#define LpiAtspcHlookupStoF(arg1, arg2, arg3, arg4)             \
            (*LPI_ATSPC_TABLE_REF->lpi_atspc_hlookup_stof)      \
            (LPI_ATSPC_GLOBAL_REF, arg1, arg2, arg3, arg4)
#define LpiAtspcHlookupStoS(arg1, arg2, arg3, arg4)             \
            (*LPI_ATSPC_TABLE_REF->lpi_atspc_hlookup_stos)      \
            (LPI_ATSPC_GLOBAL_REF, arg1, arg2, arg3, arg4)
#define LpiAtspcInfoFloat(arg1, arg2)                           \
            (*LPI_ATSPC_TABLE_REF->lpi_atspc_info_float)        \
            (LPI_ATSPC_GLOBAL_REF, arg1, arg2)
#define LpiAtspcInfoString(arg1, arg2)                          \
            (*LPI_ATSPC_TABLE_REF->lpi_atspc_info_str)          \
            (LPI_ATSPC_GLOBAL_REF, arg1, arg2)
#define LpiAtspcRound(arg1, arg2, arg3 )                        \
            (*LPI_ATSPC_TABLE_REF->lpi_atspc_round)             \
            (LPI_ATSPC_GLOBAL_REF, arg1, arg2, arg3)
#define LpiAtspcVlookupFtoF(arg1, arg2, arg3, arg4)             \
            (*LPI_ATSPC_TABLE_REF->lpi_atspc_vlookup_ftof)      \
            (LPI_ATSPC_GLOBAL_REF, arg1, arg2, arg3, arg4)
#define LpiAtspcVlookupFtoS(arg1, arg2, arg3, arg4)             \
            (*LPI_ATSPC_TABLE_REF->lpi_atspc_vlookup_ftos)      \
            (LPI_ATSPC_GLOBAL_REF, arg1, arg2, arg3, arg4)
#define LpiAtspcVlookupStoF(arg1, arg2, arg3, arg4)             \
            (*LPI_ATSPC_TABLE_REF->lpi_atspc_vlookup_stof)      \
            (LPI_ATSPC_GLOBAL_REF, arg1, arg2, arg3, arg4)
#define LpiAtspcVlookupStoS(arg1, arg2, arg3, arg4)             \
            (*LPI_ATSPC_TABLE_REF->lpi_atspc_vlookup_stos)      \
            (LPI_ATSPC_GLOBAL_REF, arg1, arg2, arg3, arg4)
#endif
#endif
