/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  lstring.h

\***************************************************************************/


/************************************************************************\

   Description:
      Header file for the mem* and str* functions in the Microsoft (R)
      runtime libraries, used for driver files that want to use the /Oi
      switch with the Microsoft C compiler, or can link with libraries
      that have ANSI- and Microsoft- compatible string routines.

\************************************************************************/

#if !defined(LSTRING_H)        /* For header files only! */
#define LSTRING_H
#ifndef _SIZE_T_DEFINED
typedef unsigned int size_t;
#define _SIZE_T_DEFINED
#endif
#ifndef NO_EXT_KEYS /* extensions enabled */
    #define _CDECL  cdecl
#else /* extensions not enabled */
    #define _CDECL
#endif /* NO_EXT_KEYS */
/* function prototypes */
void * _CDECL memchr(const void *, int, size_t);
int _CDECL memcmp(const void *, const void *, size_t);
void * _CDECL memcpy(void *, const void *, size_t);
void * _CDECL memmove(void *, const void *, size_t);
void * _CDECL memset(void *, int, size_t);
char * _CDECL strcat(char *, const char *);
int _CDECL strcmp(const char *, const char *);
char * _CDECL strcpy(char *, const char *);
size_t _CDECL strlen(const char *);
int _CDECL strncmp(const char *, const char *, size_t);
char * _CDECL strncpy(char *, const char *, size_t);
#endif   /* if !defined(LSTRING_H) */
