/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  utility.plx

\***************************************************************************/

#if !defined(UTILITY_PLX)   /* usually used only for header files */
#define UTILITY_PLX
#define ll3utility_name "UTILITY"
/* Argument definitions for C-callable functions */
#define LPI_UT_BEEP_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lslong cFreq,\
 lslong cDurn)
#define LPI_UT_SYSTEM_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmbcs) CmdStr)
#define LPI_UT_ERROR_TEXT_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lushort platferr,\
 lptr(lmhdl(lmbcs)) errmsg)
#define LPI_UT_REFCONVERT_STOI_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmbcs) inString,\
 lptr(lushort) ref)
#define LPI_UT_REFCONVERT_ITOS_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lslong lref,\
 lptr(lmbcs) outString)
#define LPI_UT_VERSION_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lptr(lmhdl(lmbcs)) prodver,\
 lptr(lfloat10) LibVer)
/* Function prototypes for C-callable functions */
lexppro (lsshort, lpi_ut_beep, LPI_UT_BEEP_ARGS);
lexppro (lsshort, lpi_ut_system, LPI_UT_SYSTEM_ARGS);
lexppro (lsshort, lpi_ut_error_text, LPI_UT_ERROR_TEXT_ARGS);
lexppro (lsshort, lpi_ut_refconvert_stoi, LPI_UT_REFCONVERT_STOI_ARGS);
lexppro (lsshort, lpi_ut_refconvert_itos, LPI_UT_REFCONVERT_ITOS_ARGS);
lexppro (lsshort, lpi_ut_version, LPI_UT_VERSION_ARGS);
typedef struct {
    lexpptr (lsshort, lpi_ut_beep, LPI_UT_BEEP_ARGS);
    lexpptr (lsshort, lpi_ut_system, LPI_UT_SYSTEM_ARGS);
    lexpptr (lsshort, lpi_ut_error_text, LPI_UT_ERROR_TEXT_ARGS);
    lexpptr (lsshort, lpi_ut_refconvert_stoi, LPI_UT_REFCONVERT_STOI_ARGS);
    lexpptr (lsshort, lpi_ut_refconvert_itos, LPI_UT_REFCONVERT_ITOS_ARGS);
    lexpptr (lsshort, lpi_ut_version, LPI_UT_VERSION_ARGS);
} util_exports;
#define LPI_UT_REFCVT_BUFLEN    4       /* SPR 121416, 10/30/90 HWG */
#if defined(LPIXPORT_H) /* macros to call the structure stuff */
#if defined(NOGLOBALDATA)
#define LPI_UT_GLOBAL_REF  LPI_CALL_DATA->util_global
#define LPI_UT_TABLE_REF   LPI_CALL_DATA->util_table
#else
#define LPI_UT_GLOBAL_REF  lts_ut_global
#define LPI_UT_TABLE_REF   lts_ut_table
#endif
#define LpiUtBeep(arg1, arg2)                          \
            (*LPI_UT_TABLE_REF->lpi_ut_beep)           \
            (LPI_UT_GLOBAL_REF, arg1, arg2)
#define LpiUtSystem(arg1)                              \
            (*LPI_UT_TABLE_REF->lpi_ut_system)         \
            (LPI_UT_GLOBAL_REF, arg1)
#define LpiUtErrorText(arg1, arg2)                     \
            (*LPI_UT_TABLE_REF->lpi_ut_error_text)     \
            (LPI_UT_GLOBAL_REF, arg1, arg2)
#define LpiUtRefConvertStoI(arg1, arg2)                \
            (*LPI_UT_TABLE_REF->lpi_ut_refconvert_stoi)\
            (LPI_UT_GLOBAL_REF, arg1, arg2)
#define LpiUtRefConvertItoS(arg1, arg2 )               \
            (*LPI_UT_TABLE_REF->lpi_ut_refconvert_itos)\
            (LPI_UT_GLOBAL_REF, arg1, arg2)
#define LpiUtVersion(arg1, arg2)                       \
            (*LPI_UT_TABLE_REF->lpi_ut_version)        \
            (LPI_UT_GLOBAL_REF, arg1, arg2)
#endif
#endif
